<?php

/*
  get data from /proc system and parse for yahoo widget
  LINE 1, UPTIME: DAY:HOUR:MINUTE
  LINE 2, LOAD: USER, NICE, SYSTEM, IDLE
 */

define('T_DAY', 86400);
define('T_HOUR', 3600);
define('T_MINUTE', 60);


define('USE_OPEN', false); //put to false to make shell calls and avoid base dirs, else true is for opening files

/* start -- uptime */

if (USE_OPEN)
	$data = file("/proc/uptime");
else
{
	ob_start();
	system("cat /proc/uptime");
	$data = ob_get_contents();
	ob_end_clean();
	
	$data = explode("\n", $data);
}
	
$data = $data[0];
$data = explode(" ", $data);
$uptime = $data[0];

$day = floor($uptime / T_DAY);
$uptime = $uptime - ($day * T_DAY);

$hour = floor($uptime / T_HOUR);
$uptime = $uptime - ($hour * T_HOUR);

$minute = floor($uptime / T_MINUTE);
print sprintf("%02d:%02d:%02d\n", $day, $hour, $minute);

/* end -- uptime */


/* start -- load */
if (USE_OPEN)
	$data = file("/proc/stat");
else
{
	ob_start();
	system("cat /proc/stat");
	$data = ob_get_contents();
	ob_end_clean();
	
	$data = explode("\n", $data);
}

$data = $data[0];
$data = explode(" ", $data);

$user = $data[2];
$nice = $data[3];
$system = $data[4];
$idle = $data[5];
$total = $user + $nice + $system + $idle;

$user = ($user * 100.0)/$total;
$nice = ($nice * 100.0)/$total;
$system = ($system * 100.0)/$total;
$idle  = ($idle  * 100.0)/$total;

print sprintf("%.2f:%.2f:%.2f:%.2f\n", $user, $nice, $system, $idle);

/* end -- load */

/* server name */
print $_SERVER["SERVER_NAME"] . "\n";

?>
